'sGUI
#include "sGUI\sGUI.bas"
#include once "sGUI\SimpleGadget.bas"
#include once "sGUI\StringGadget.bas"
#include once "sGUI\ScrollBar.bas"
#include once "sGUI\MultiLineEditBox.bas"
#include once "sGUI\MessageBox.bas"
#include once "sGUI\ComboBox.bas"
#include once "sGUI\ClickMapGadget.bas"
#include once "sGUI\Label.bas"
using sGUI

'Netzwerk TSNE
#include "Network\eazyTSNE.bas"

'Pseudo EingabeBoxen, bentigen sGUI und Netzwerkzeugs
#include "Requests\GameModeRequest.bas"
#include "Requests\IPPortRequest.bas"
#include "Requests\PortRequest.bas"

'das eigentliche Spiel, also der Regelwchter
#include "GameIncludes\Game.bi"

'Grafiken
#include "GameIncludes\GFXStuff.bas"

screenres 600,600,32,,&H04
width 600\8,600\16

'GUI Vorbereitungen************************************************************
CustomColors=1
BackGroundColor         =&H9080AD
TextColor               =black
GadgetColor			        =&HFF9E3F
MenuColor               =BackGroundColor
MenuTextColor           =&HFFFF00
MenuGhostedColor        =ShiftRGB (MenuColor,-contrast/2)
InitGFX

'Spiel erzeugen****************************************************************
dim as Bebalone Game

dim as integer gamemode
dim as integer mycolor,oppcolor,myActionCounter,oppActionCounter,stpos_num
dim as string myname,myGameString,oppname,oppGameString
dim as string MsgIn,StartTag
dim as integer sendsync,syncdelay,nextsynctime
dim as string ScreenTitle
dim as integer mbresult,netresult

dim as integer stpos_count=1

'dynamische Arrays
'ldt die Datei "StartingPositions.cfg"
redim as string stpos_names(1 to stpos_count)
redim as string stpos_definition(1 to stpos_count)
dim as integer ff
dim as string s
ff=freefile
open "StartingPositions.cfg" for input as ff
  do
    input #ff, stpos_names(stpos_count)
    
    for i as integer= 1 to 9
      input #ff, s
      stpos_definition(stpos_count) &=s
    next i

    if eof(ff)=0 then
      stpos_count +=1
      redim preserve stpos_names(1 to stpos_count)
      redim preserve stpos_definition(1 to stpos_count)
    end if

  loop until eof(ff)
close

'Initialwerte
mycolor=1
oppcolor=2
sendsync=0
syncdelay=5
ScreenTitle="Bebalone V0.40      "

'Alle Grafiken Laden und Hintergrund setzen************************************
dim as any ptr g(5)
GFXLoader (g())
dim as HollowOffset h(1 to 61)'OffsetTabelle fr die Grafik des Spielfeldes
SetHOffsets(h())'Initiieren dieser Offsets
FillA(0,0,600,600,BackGroundColor,0)

'SpielModus abfragen***********************************************************
gamemode=GameModeRequest (100,150)'0=offline 1=Server 2=Client

'Netzwerkzeugs*****************************************************************
dim as integer CS,oCS'Hilfsvariablen um auf eine Verbindungsstatusnderung zu reagieren
oCS=0

'Bildschirm aufbauen***********************************************************
dim as integer pfposx,pfposy,arposx,arposy,coposx,coposy
pfposx=20
pfposy=55
arposx=pfposx+342
arposy=pfposy+98
coposx=pfposx+300
coposy=pfposy

Game.InitBoard'Grundstellung
ShowPlayField (pfposx,pfposy,Game , h(), g() )
ShowArrows (arposx,arposy,Game , h(), g() )
ShowOuts (coposx,coposy,Game , h(), g() )

'EventHandle fr GUI erzeugen *************************************************
dim as EventHandle ptr event= new EventHandle

'Gadgets erzeugen**************************************************************
dim as Gadget ptr playfield,arrows,msglog,msginput,msgsend,stpos_selector,startcancel,firstplayer,info
'fr den jeweiligen Spielmodus sind die controls unterschiedlich
select case gamemode
	case 0
    windowtitle ScreenTitle & "Offline"

    info=AddSimpleGadget(event,549,15,22,22,"i")
    startcancel=AddSimpleGadget(event,401,300,170,30,"Starte Spiel")
    
    stpos_selector=AddComboBox(event,20,15,15,8)
    for i as integer=1 to stpos_count
      TO_AppendLine(stpos_selector, stpos_names(i))
    next i
    UpdateGadget(stpos_selector)
    SetComboBoxVal(stpos_selector,1)

    msglog=AddMultiLineEditBox (event,30,360,65,10,0)
    TO_AppendLine (msglog,"***** Willkommen zu Bebalone *****")
    UpdateGadget(msglog)

    playfield=AddClickMapGadget(event,pfposx,pfposy,"gfx\clickmappf.bmp")
    arrows   =AddClickMapGadget(event,arposx,arposy,"gfx\clickmapar.bmp")

    GadgetOn(info,msglog)
    GadgetSleep(playfield,arrows)

  case 1
    windowtitle ScreenTitle & "Server"

    info=AddSimpleGadget(event,549,15,22,22,"i")

    msglog=AddMultiLineEditBox (event,30,360,65,10,0)
    TO_AppendLine (msglog,"***** Willkommen zu Bebalone *****")
    UpdateGadget(msglog)

    startcancel=AddSimpleGadget(event,401,300,170,30,"Spiel abbrechen")

    msginput=AddStringGadget(event,30,557,56,"",,,,1)
    msgsend=AddSimpleGadget(event,501,558,70,20,"Sende")

    playfield=AddClickMapGadget(event,pfposx,pfposy,"gfx\clickmappf.bmp")
    arrows   =AddClickMapGadget(event,arposx,arposy,"gfx\clickmapar.bmp")

    GadgetOn(info,msglog)
    GadgetSleep(startcancel,arrows)

    TO_AppendLine (msglog,"Suche nach IP... bitte warten")
    UpdateGadget  (msglog)
    TO_AppendLine (msglog,"IP: " & AskDYNDNS)
    TO_AppendLine (msglog,"Bei Fehlschlag bitte die eigene IP ueber")
    TO_AppendLine (msglog,"entsprechende Seiten im Webbrowser ermitteln")
    TO_AppendLine (msglog,"zB.: wieistmeineip.de , dyndns.org")
    TO_AppendLine (msglog,"Diese IP und der gegebenenfalls geaenderte Port")
    TO_AppendLine (msglog,"ist dem Client zu uebermitteln,")
    TO_AppendLine (msglog,"damit dieser eine Verbindung herstellen kann!")
    UpdateGadget  (msglog)

    GadgetSleep(info,arrows)
    PortRequest (40,100)
    SN.CreateServer
    RestoreActivation(info,arrows)

    myname="Server"
    oppname="Client"

  case 2
    windowtitle ScreenTitle & "Client"

    info=AddSimpleGadget(event,549,15,22,22,"i")
    startcancel=AddSimpleGadget(event,401,300,170,30,"Spiel starten")

    stpos_selector=AddComboBox(event,20,15,15,8)
    for i as integer=1 to stpos_count
      TO_AppendLine(stpos_selector, stpos_names(i))
    next i
    UpdateGadget(stpos_selector)
    SetComboBoxVal(stpos_selector,1)    
    
    firstplayer=AddComboBox(event,290,15,14,2)
    TO_AppendLine(firstplayer,"Client beginnt")
    TO_AppendLine(firstplayer,"Server beginnt")
    UpdateGadget(firstplayer)
    SetComboBoxVal(firstplayer,1)
    
    msglog=AddMultiLineEditBox (event,30,360,65,10,0)
    TO_AppendLine (msglog,"***** Willkommen zu Bebalone *****")
    UpdateGadget(msglog)
    
    msginput=AddStringGadget(event,30,557,56,"",,,,1)
    msgsend=AddSimpleGadget(event,501,558,70,20,"Sende")

    playfield=AddClickMapGadget(event,pfposx,pfposy,"gfx\clickmappf.bmp")
    arrows   =AddClickMapGadget(event,arposx,arposy,"gfx\clickmapar.bmp")

    GadgetSleep(info,arrows)    
    do
      mbresult=0
      IPPortRequest (40,100)
      netresult=SN.CreateClient
      if netresult=0 then mbresult=sGUI.MessageBox(40,100,"Es konnte keine Verbinung|zum Server aufgebaut werden.|Bei Abbruch bitte das Programm|ueber den Closebutton|beenden.","Fehlschlag",MBType_RETRYCANCEL)      
    loop until mbresult<>MBButton_RETRY
    
    if netresult<>0 then
      GadgetOn(info,msglog)
      GadgetSleep(msginput,arrows)
      myname="Client"
      oppname="Server"      
    end if

  end select

'******************************************************************************
'******************************************************************************
'Eventloop*********************************************************************
do
  event->xSleep(0)'0=nicht warten, da das "Netzwerk" permanent berprft wird

  select case gamemode
'Offline Game******************************************************************
    case 0
      if event->GADGETMESSAGE then                            'Gadget Events
        select case event->GADGETMESSAGE
          case arrows                                        	'Zug in gewnscht Richtung machen / Regelberprfung /Spielerwechsel
            if Game.MoveBalls(GetClickMapColor(arrows)) then 	'Game
              ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
              ShowArrows (arposx,arposy,Game , h(), g() )
              ShowOuts (coposx,coposy,game,h(),g())
            end if
            if game.GetOutBlack=6 or game.GetOutWhite=6 then 	'wenn 6 Kugeln einer Farbe draussen sind,ist das Spiel zu Ende
              GadgetSleep(playfield)                          'einzig die GUI weiss davon noch nichts, wird jetzt nachgeholt
              GadgetSleep(arrows)                             'schalte die Gadgets in den Sleep Modus
            end if
          case playfield                                     	'Selektion der Kugeln
            Game.PlayFieldClick(GetClickMapColor(playfield))  'Game
            ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
            ShowArrows (arposx,arposy,Game , h(), g() )
            ShowOuts (coposx,coposy,game,h(),g())

          case startcancel
            select case Game.GetGame
            case 0
              Game.StartGame (stpos_definition(GetComboBoxVal(stpos_selector)))      'Game
              ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
              ShowArrows (arposx,arposy,Game , h(), g() )
              ShowOuts (coposx,coposy,game,h(),g())
              GadgetOn(playfield)                         'GUI
              GadgetOn(arrows)
              GadgetSleep(stpos_selector)
              SetCaption(startcancel,"Spiel abbrechen")
            case 1,2
              Game.StopGame                               'Game
              ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
              ShowArrows (arposx,arposy,Game , h(), g() )
              ShowOuts (coposx,coposy,game,h(),g())
              GadgetSleep(playfield)                      'GUI
              GadgetSleep(arrows)
              GadgetOn(stpos_selector)
              SetCaption(startcancel,"Starte Spiel")
            end select
          case stpos_selector
            Game.InitBoard (stpos_definition(GetComboBoxVal(stpos_selector)))            'Game
            ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
            ShowArrows (arposx,arposy,Game , h(), g() )
            ShowOuts (coposx,coposy,game,h(),g())
          case info
            GadgetSleep(info,arrows)
            sGUI.MessageBox(120,170,"Vielen Dank an ThePuppetMaster|fuer seine TSNE Bibliothek, sowie|MOD fuer seine Beispiele, wie man selbige|Bibliothek nutzen kann.","Credits",1)
            RestoreActivation(info,arrows)
        end select
      end if
      
'******************************************************************************
'******************************************************************************
'******************************************************************************

'Online Game Server/Client*****************************************************
    case is >0
      if event->GADGETMESSAGE then                            'Gadget Events
        select case event->GADGETMESSAGE
          case arrows                                        	'Zug in gewnscht Richtung machen / Regelberprfung /Spielerwechsel
            if (mycolor=Game.GetGame) then
              if Game.MoveBalls(GetClickMapColor(arrows)) then 	'Game
                ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
                ShowArrows (arposx,arposy,Game , h(), g() )
                ShowOuts (coposx,coposy,game,h(),g())
                SN.SendMessage("[MOV]" & Game.GetGameString)
                sendsync=1
                nextsynctime=timer+syncdelay
              end if
            end if
            if game.GetOutBlack=6 or game.GetOutWhite=6 then 	'wenn 6 Kugeln einer Farbe draussen sind,ist das Spiel zu Ende
              ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
              ShowArrows (arposx,arposy,Game , h(), g() )
              ShowOuts (coposx,coposy,game,h(),g())
              GadgetSleep(playfield,arrows)
              SN.SendMessage("[BRK]")
              sendsync=0
            end if

          case playfield                                     	'Selektion der Kugeln
            if mycolor=game.GetGame then
              if Game.PlayFieldClick(GetClickMapColor(playfield)) then      'Game
                ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
                ShowArrows (arposx,arposy,Game , h(), g() )
                ShowOuts (coposx,coposy,game,h(),g())
                SN.SendMessage("[SEL]" & Game.GetGameString)
              end if
            end if

          case msginput,msgsend
            if len(GetString(msginput)) then
              SN.SendMessage("[TXT]" & GetString(msginput))
              TO_AppendLine (msglog,myname & "> " & GetString(msginput))
              TO_SetCursor(msglog, TO_GetLines(msglog) ,1)
              UpdateGadget (msglog)
              SetString(msginput,"")
            end if
          
          case info
            GadgetSleep(info,arrows)
            sGUI.MessageBox(120,170,"Vielen Dank an ThePuppetMaster|fuer seine TSNE Bibliothek, sowie|MOD fuer seine Beispiele, wie man selbige|Bibliothek nutzen kann.","Credits",1)
            RestoreActivation(info,arrows)

          case startcancel
            select case Game.GetGame
            case 0
              if GetComBoBoxVal(firstplayer)=1 then
                mycolor=1
                oppcolor=2
              else
                mycolor=2
                oppcolor=1                
              end if
   						sendsync=0
              Game.StartGame (stpos_definition(GetComboBoxVal(stpos_selector)))                          'Game
              SN.SendMessage("[GAM]" & chr(GetComboBoxVal(stpos_selector)) & chr(oppcolor))      'Spielart an Server senden
              ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
              ShowArrows (arposx,arposy,Game , h(), g() )
              ShowOuts (coposx,coposy,game,h(),g())
              if mycolor=1 then
                TO_AppendLine (msglog,"Spielstart: Client=Schwarz vs. Server=Weiss")
              else
                TO_AppendLine (msglog,"Spielstart: Server=Schwarz vs. Client=Weiss")  
              end if
              TO_SetCursor(msglog, TO_GetLines(msglog) ,1)
              UpdateGadget (msglog)
                            
              GadgetOn(playfield,arrows)                  'GUI         
              GadgetSleep(stpos_selector,firstplayer)
              SetCaption(startcancel,"Spiel abbrechen")
            
            case 1,2
              sendsync=0
              Game.StopGame                               'Game
              ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
              ShowArrows (arposx,arposy,Game , h(), g() )
              ShowOuts (coposx,coposy,game,h(),g())
              SN.SendMessage("[BRK]")                     'Sende Abbruchsignal an Server
              TO_AppendLine (msglog,myname & " bricht Spiel ab")
              TO_SetCursor(msglog, TO_GetLines(msglog) ,1)
              UpdateGadget (msglog)                
              if myname="Server" then
                GadgetSleep(startcancel)
              else
                GadgetSleep(playfield,arrows)
                GadgetOn(stpos_selector,firstplayer)
                SetCaption(startcancel,"Starte Spiel")
              end if
            end select
          case stpos_selector
            Game.InitBoard (stpos_definition(GetComboBoxVal(stpos_selector)))            'Game
            ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
            ShowArrows (arposx,arposy,Game , h(), g() )
            ShowOuts (coposx,coposy,game,h(),g())
            SN.SendMessage("[SNC]" & Game.GetGameString)
        end select
      end if

    'Verbindungsstatus prfen
    'wenn sich etwas verndert hat, entsprechende Aktionen
    CS=SN.GetConnectionStatus
    if CS>oCS then            'einmalige Aktion bei Verbindungsaufbau
      GadgetOn(msginput,msgsend)
    elseif CS<oCS  then     'einmalige Action bei Verbindungsabbruch
      GadgetSleep(msginput,msgsend)
    end if
    oCS=CS

        'eingehende Messages vom Server/Client
    if SN.MessagePing then
      MsgIn=SN.GetMessage
      StartTag=left(MsgIn,5)
      MsgIn=mid(MsgIn,6,len(MsgIn)-10)

      select case StartTag
        case "[SEL]"
          sendsync=0
          oppGameString=MsgIn
          Game.SetGameString(oppGameString)
          ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
          ShowArrows (arposx,arposy,Game , h(), g() )
          ShowOuts (coposx,coposy,game,h(),g())

        case "[MOV]"
          oppGameString=MsgIn
          Game.SetGameString(oppGameString)
          ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
          ShowArrows (arposx,arposy,Game , h(), g() )
          ShowOuts (coposx,coposy,game,h(),g())
          TO_AppendLine (msglog,myname &" ist am Zug")
          TO_SetCursor(msglog, TO_GetLines(msglog) ,1)
          UpdateGadget (msglog)

        case "[SNC]"
          oppGameString=MsgIn         
          if Game.GetGameString<>oppGameString then
            Game.SetGameString(oppGameString)
            ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
            ShowArrows (arposx,arposy,Game , h(), g() )
            ShowOuts (coposx,coposy,game,h(),g())              
            if Game.GetGame then
              TO_AppendLine (msglog,"Spieldaten wurden synchronisiert: " & myname & " ist am Zug")
              TO_SetCursor(msglog, TO_GetLines(msglog) ,1)
              UpdateGadget (msglog)
            end if
          end if
        
        case "[TXT]"
          TO_AppendLine (msglog,oppname & "> "& MsgIn)
          TO_SetCursor(msglog, TO_GetLines(msglog) ,1)
          UpdateGadget (msglog)

        case "[GAM]"
          stpos_num=MsgIn[0]
          mycolor=MsgIn[1]
					Game.StartGame (stpos_definition(stpos_num))
          ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
          ShowArrows (arposx,arposy,Game , h(), g() )
        	ShowOuts (coposx,coposy,game,h(),g())
					GadgetOn(startcancel)
          GadgetOn(playfield,arrows)
          if mycolor=1 then
            TO_AppendLine (msglog,"Spielstart: Server=Schwarz vs. Client=Weiss")
          else
            TO_AppendLine (msglog,"Spielstart: Client=Schwarz vs. Server=Weiss")
          end if
          TO_SetCursor(msglog, TO_GetLines(msglog) ,1)
          UpdateGadget (msglog)

        case "[BRK]"
          sendsync=0
          Game.StopGame
          ShowPlayField (pfposx,pfposy,Game , h(), g() )  'Grafik
          ShowArrows (arposx,arposy,Game , h(), g() )
        	ShowOuts (coposx,coposy,game,h(),g())
  				GadgetSleep(playfield)
  				GadgetSleep(arrows)
          if myname="Server" then
            GadgetSleep(startcancel)
          else'myname="Client"
            GadgetOn(stpos_selector,firstplayer)
            SetCaption(startcancel,"Starte Spiel")
          end if
          TO_AppendLine (msglog,oppname & " bricht Spiel ab")
          TO_SetCursor(msglog, TO_GetLines(msglog) ,1)
          UpdateGadget (msglog)
      end select
    end if

    if sendsync then                                          'Synchronisation bei Datenverlust
      if nextsynctime<=timer then
        SN.SendMessage("[SNC]" & Game.GetGameString)
        nextsynctime=timer+syncdelay
      end if
    end if

    if SN.StatusTextPing then                                 'Messages vom Netzwerkmodul
      TO_AppendLine (msglog,SN.GetStatusText)
      TO_SetCursor(msglog, TO_GetLines(msglog) ,1)
      UpdateGadget (msglog)
    end if

  end select

  if Game.MessagePing then                                  'Messages durch "Gameengine"
    TO_AppendLine (msglog,Game.GetMessage)
    TO_SetCursor(msglog, TO_GetLines(msglog) ,1)
    UpdateGadget (msglog)
  end if

loop until event->EXITEVENT
'Ende Eventloop****************************************************************
'******************************************************************************
'******************************************************************************

'Aufrumen*********************************************************************
delete event'EventHandle/GUI lschen
GFXDestroyer (g())'alle Grafiken lschen
'Netzwerk zerstrt sich durch Destructor selbst
